----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Micâh - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------

local DF = DOF_namespace
local _

function DF:GetBleedAbilityDamageCoefficient(docActive, spell, spellId)
    
    --local spellShowsSavageRoar=false
    local spellShowsTigersFuror=false
    local spellShowsBloodtalons=false
    local powerFlags=0

    powerFlags = DF_powerId[tonumber(spellId)]
    if (powerFlags) then        
      --spellShowsSavageRoar = spellShowsSavageRoar or DF:hasbit(powerFlags,DF:bit(1))
      spellShowsTigersFuror = spellShowsTigersFuror or DF:hasbit(powerFlags,DF:bit(2))
      spellShowsBloodtalons = spellShowsBloodtalons or DF:hasbit(powerFlags,DF:bit(3))
    end

    -- nouvelle formule, ne tiens compte que du rugissement, fureur du tigre et bloodtalons
    local damageCoeff=1

    --if DF:spell_exist(nil,DF.SavageRoarName,"player","HELPFUL|PLAYER",false) and spellShowsSavageRoar then  -- savage roar
    --	damageCoeff=damageCoeff*1.15
    --end
    if DF:spell_exist(nil,DF.TigerFuryName,"player","HELPFUL|PLAYER",false) and spellShowsTigersFuror then   -- tiger furor
    	damageCoeff=damageCoeff*1.15
    end
    if docActive and spellShowsBloodtalons then  -- bloodtalons damage boost 
      damageCoeff=damageCoeff*1.25
    end
    if (spell==DF.RakeName) and (IsStealthed() or DF:spell_exist(nil,DF.IncarnationName,"player","HELPFUL|PLAYER",false)) then  -- rake when prowling or with incarnation
      damageCoeff=damageCoeff*2.00
    end

    return damageCoeff
    
end

function DF:GetDotPower(spell,docActive,forceCP)
   
    local bleedCoeff
    local CP = UnitPower('player', 4)
    local dotPower=0
    local bleedBase
    
    if DF.dotPowerDatas[spell] then
	
			bleedCoeff = DF:GetBleedAbilityDamageCoefficient(docActive, spell, DF.dotPowerDatas[spell].spellId)
			
	    if forceCP then CP=forceCP end
	    if DF.dotPowerDatas[spell].basecp==0 then CP=1 end
	    
	    bleedBase = (DF.dotPowerDatas[spell].base
	                   +(DF.dotPowerDatas[spell].basecp * CP))
	                   +((DF.dotPowerDatas[spell].baseap * DF.playerAP) * CP)
	    
	    dotPower = bleedCoeff * bleedBase

	  end
	  
    return dotPower
    
end

function DF:GetAbiPower(spellid)
	local targetID=UnitGUID("playertarget")
	if targetID and DF.abiPowers[targetID] and DF.abiPowers[targetID][spellid] then
		return DF.abiPowers[targetID][spellid]
	else
		return nil
	end
end

